#include "text.h"
#include <GL/gl.h>
#include <cstring>

Text::Text(Font *f, const char *t) : font(f) {
	text = new char[strlen(t) + 2];
	strcpy(text, t);
	memset(pos, 0, sizeof(vector));
}

Text::~Text() {
	delete[] text;
}

void tegn_firkant1(int);

void tegn_firkant1(int tex) {
	glPushMatrix();
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glDisable(GL_LIGHTING);
	glBlendFunc(GL_ONE,GL_ONE_MINUS_DST_COLOR);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	glBindTexture(GL_TEXTURE_2D, tex);
	glEnable(GL_COLOR_MATERIAL);
	glTranslatef(0.0, 0.0, -5.0);
	glColor3f(1.0, 1.0, 1.0);
	glNormal3f(0.0, 0.0, 1.0);
	glBegin(GL_POLYGON); {
		glTexCoord2i(0, 1);
		glVertex3f(-1.0, -1.0, 0.0);
		glTexCoord2i(1, 1);
		glVertex3f(1.0, -1.0, 0.0);
		glTexCoord2i(1, 0);
		glVertex3f(1.0, 1.0, 0.0);
		glTexCoord2i(0, 0);
		glVertex3f(-1.0, 1.0, 0.0);
	} glEnd();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glEnable(GL_LIGHTING);
	glPopMatrix();


}


void Text::draw(const int &i, float y) {
	
	/*
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glDisable(GL_LIGHTING);
	glDisable(GL_DEPTH_TEST);
	glColor4f(1,1,1,1);
	glBlendFunc(GL_ONE, GL_ONE);*/


	glDisable(GL_DEPTH_TEST);
	#define dx 1
	#define dy 1

	glTranslatef(pos[X], pos[Y], pos[Z]);
	/*
	glBindTexture(GL_TEXTURE_2D, font->get_letters(text[i]));
	glBindTexture(GL_TEXTURE_2D, 256);
*/
	glTranslatef(2, 0.0, 0.0);
	glPushMatrix();
	glTranslatef(0.0, sin(((int)text+i))*1.2, 0.0);
	tegn_firkant1(font->get_letters(text[i]));
	glPopMatrix();
/*	if (text[i] != ' ') {

		glBegin(GL_POLYGON);
			glTexCoord2f(0, 1);
			glVertex2f(dx, 0);
			glTexCoord2f(1, 1);
			glVertex2f(dx+(dx-dx/10), 0);
			glTexCoord2f(1, 0);
			glVertex2f(dx+(dx-dx/10), dy);
			glTexCoord2f(0, 0);
			glVertex2f(dx, dy);
		glEnd();
	}
	
	glTranslatef(-i*dx, 0.0, 0.0);
	
	glTranslatef(-pos[X], -pos[Y], -pos[Z]);

	for(int i = 0; i < strlen(text); i++) {

	}
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_LIGHTING);
	glEnable(GL_DEPTH_TEST);*/
}


void Text::draw(float y) {
	for(int i = 0; i < strlen(text); i++) {
		draw(i, y);
	}
}

