#ifndef TEXTURE_H
#define TEXTURE_H

#include <GL/gl.h>

typedef struct {
	unsigned char *data;
	unsigned short height;
	unsigned short width;
} image_t;

class texture {
	bool repeat;
	GLuint num;

public:
	texture(const char* filename);

	inline int get_num() {
		return num;
	}

	~texture();

};

#endif
